/* minefield.c generated by valac 0.46.0, the Vala compiler
 * generated from minefield.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>

typedef enum  {
	FLAG_TYPE_NONE,
	FLAG_TYPE_FLAG,
	FLAG_TYPE_MAYBE
} FlagType;

#define TYPE_FLAG_TYPE (flag_type_get_type ())

#define TYPE_LOCATION (location_get_type ())
#define LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCATION, Location))
#define LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOCATION, LocationClass))
#define IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCATION))
#define IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOCATION))
#define LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOCATION, LocationClass))

typedef struct _Location Location;
typedef struct _LocationClass LocationClass;
typedef struct _LocationPrivate LocationPrivate;
enum  {
	LOCATION_0_PROPERTY,
	LOCATION_NUM_PROPERTIES
};
static GParamSpec* location_properties[LOCATION_NUM_PROPERTIES];

#define TYPE_NEIGHBOUR (neighbour_get_type ())
typedef struct _Neighbour Neighbour;

#define TYPE_MINEFIELD (minefield_get_type ())
#define MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINEFIELD, Minefield))
#define MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINEFIELD, MinefieldClass))
#define IS_MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINEFIELD))
#define IS_MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINEFIELD))
#define MINEFIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINEFIELD, MinefieldClass))

typedef struct _Minefield Minefield;
typedef struct _MinefieldClass MinefieldClass;
typedef struct _MinefieldPrivate MinefieldPrivate;
enum  {
	MINEFIELD_0_PROPERTY,
	MINEFIELD_N_CLEARED_PROPERTY,
	MINEFIELD_IS_COMPLETE_PROPERTY,
	MINEFIELD_N_FLAGS_PROPERTY,
	MINEFIELD_USE_AUTOFLAG_PROPERTY,
	MINEFIELD_ELAPSED_PROPERTY,
	MINEFIELD_PAUSED_PROPERTY,
	MINEFIELD_NUM_PROPERTIES
};
static GParamSpec* minefield_properties[MINEFIELD_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MINEFIELD_CLOCK_STARTED_SIGNAL,
	MINEFIELD_PAUSED_CHANGED_SIGNAL,
	MINEFIELD_TICK_SIGNAL,
	MINEFIELD_REDRAW_SECTOR_SIGNAL,
	MINEFIELD_MARKS_CHANGED_SIGNAL,
	MINEFIELD_EXPLODE_SIGNAL,
	MINEFIELD_CLEARED_SIGNAL,
	MINEFIELD_NUM_SIGNALS
};
static guint minefield_signals[MINEFIELD_NUM_SIGNALS] = {0};

struct _Location {
	GObject parent_instance;
	LocationPrivate * priv;
	gboolean has_mine;
	gboolean cleared;
	FlagType flag;
	gint adjacent_mines;
};

struct _LocationClass {
	GObjectClass parent_class;
};

struct _Neighbour {
	gint x;
	gint y;
};

struct _Minefield {
	GObject parent_instance;
	MinefieldPrivate * priv;
	guint width;
	guint height;
	guint n_mines;
	Location** locations;
	gint locations_length1;
	gint locations_length2;
	gboolean exploded;
	gboolean placed_mines;
	gboolean _use_autoflag;
};

struct _MinefieldClass {
	GObjectClass parent_class;
};

struct _MinefieldPrivate {
	guint _n_cleared;
	guint _n_flags;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};

static gpointer location_parent_class = NULL;
static gint Minefield_private_offset;
static gpointer minefield_parent_class = NULL;

GType flag_type_get_type (void) G_GNUC_CONST;
GType location_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Location, g_object_unref)
Location* location_new (void);
Location* location_construct (GType object_type);
static void location_finalize (GObject * obj);
GType neighbour_get_type (void) G_GNUC_CONST;
Neighbour* neighbour_dup (const Neighbour* self);
void neighbour_free (Neighbour* self);
GType minefield_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Minefield, g_object_unref)
Minefield* minefield_new (guint width,
                          guint height,
                          guint n_mines);
Minefield* minefield_construct (GType object_type,
                                guint width,
                                guint height,
                                guint n_mines);
gboolean minefield_is_clock_started (Minefield* self);
gdouble minefield_get_elapsed (Minefield* self);
gboolean minefield_has_mine (Minefield* self,
                             guint x,
                             guint y);
gboolean minefield_is_cleared (Minefield* self,
                               guint x,
                               guint y);
gboolean minefield_is_location (Minefield* self,
                                gint x,
                                gint y);
void minefield_multi_release (Minefield* self,
                              guint x,
                              guint y);
FlagType minefield_get_flag (Minefield* self,
                             guint x,
                             guint y);
guint minefield_get_n_adjacent_mines (Minefield* self,
                                      guint x,
                                      guint y);
gboolean minefield_get_use_autoflag (Minefield* self);
void minefield_clear_mine (Minefield* self,
                           guint x,
                           guint y);
void minefield_set_flag (Minefield* self,
                         guint x,
                         guint y,
                         FlagType flag);
static void minefield_place_mines (Minefield* self,
                            guint x,
                            guint y);
static void minefield_start_clock (Minefield* self);
static void minefield_clear_mines_recursive (Minefield* self,
                                      guint x,
                                      guint y);
static void minefield_stop_clock (Minefield* self);
gboolean minefield_get_is_complete (Minefield* self);
gboolean minefield_has_flag_warning (Minefield* self,
                                     guint x,
                                     guint y);
static void minefield_start_timer (Minefield* self);
static gboolean minefield_timeout_cb (Minefield* self);
static gboolean _minefield_timeout_cb_gsource_func (gpointer self);
static void minefield_continue_clock (Minefield* self);
guint minefield_get_n_cleared (Minefield* self);
guint minefield_get_n_flags (Minefield* self);
void minefield_set_use_autoflag (Minefield* self,
                                 gboolean value);
gboolean minefield_get_paused (Minefield* self);
void minefield_set_paused (Minefield* self,
                           gboolean value);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void minefield_finalize (GObject * obj);
static void _vala_minefield_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_minefield_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const Neighbour neighbour_map[8] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

GType
flag_type_get_type (void)
{
	static volatile gsize flag_type_type_id__volatile = 0;
	if (g_once_init_enter (&flag_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FLAG_TYPE_NONE, "FLAG_TYPE_NONE", "none"}, {FLAG_TYPE_FLAG, "FLAG_TYPE_FLAG", "flag"}, {FLAG_TYPE_MAYBE, "FLAG_TYPE_MAYBE", "maybe"}, {0, NULL, NULL}};
		GType flag_type_type_id;
		flag_type_type_id = g_enum_register_static ("FlagType", values);
		g_once_init_leave (&flag_type_type_id__volatile, flag_type_type_id);
	}
	return flag_type_type_id__volatile;
}

Location*
location_construct (GType object_type)
{
	Location * self = NULL;
#line 18 "../src/minefield.vala"
	self = (Location*) g_object_new (object_type, NULL);
#line 18 "../src/minefield.vala"
	return self;
#line 246 "minefield.c"
}

Location*
location_new (void)
{
#line 18 "../src/minefield.vala"
	return location_construct (TYPE_LOCATION);
#line 254 "minefield.c"
}

static void
location_class_init (LocationClass * klass,
                     gpointer klass_data)
{
#line 18 "../src/minefield.vala"
	location_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = location_finalize;
#line 265 "minefield.c"
}

static void
location_instance_init (Location * self,
                        gpointer klass)
{
#line 21 "../src/minefield.vala"
	self->has_mine = FALSE;
#line 24 "../src/minefield.vala"
	self->cleared = FALSE;
#line 27 "../src/minefield.vala"
	self->flag = FLAG_TYPE_NONE;
#line 30 "../src/minefield.vala"
	self->adjacent_mines = 0;
#line 280 "minefield.c"
}

static void
location_finalize (GObject * obj)
{
	Location * self;
#line 18 "../src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOCATION, Location);
#line 18 "../src/minefield.vala"
	G_OBJECT_CLASS (location_parent_class)->finalize (obj);
#line 291 "minefield.c"
}

GType
location_get_type (void)
{
	static volatile gsize location_type_id__volatile = 0;
	if (g_once_init_enter (&location_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Location), 0, (GInstanceInitFunc) location_instance_init, NULL };
		GType location_type_id;
		location_type_id = g_type_register_static (G_TYPE_OBJECT, "Location", &g_define_type_info, 0);
		g_once_init_leave (&location_type_id__volatile, location_type_id);
	}
	return location_type_id__volatile;
}

Neighbour*
neighbour_dup (const Neighbour* self)
{
	Neighbour* dup;
#line 34 "../src/minefield.vala"
	dup = g_new0 (Neighbour, 1);
#line 34 "../src/minefield.vala"
	memcpy (dup, self, sizeof (Neighbour));
#line 34 "../src/minefield.vala"
	return dup;
#line 317 "minefield.c"
}

void
neighbour_free (Neighbour* self)
{
#line 34 "../src/minefield.vala"
	g_free (self);
#line 325 "minefield.c"
}

GType
neighbour_get_type (void)
{
	static volatile gsize neighbour_type_id__volatile = 0;
	if (g_once_init_enter (&neighbour_type_id__volatile)) {
		GType neighbour_type_id;
		neighbour_type_id = g_boxed_type_register_static ("Neighbour", (GBoxedCopyFunc) neighbour_dup, (GBoxedFreeFunc) neighbour_free);
		g_once_init_leave (&neighbour_type_id__volatile, neighbour_type_id);
	}
	return neighbour_type_id__volatile;
}

static inline gpointer
minefield_get_instance_private (Minefield* self)
{
	return G_STRUCT_MEMBER_P (self, Minefield_private_offset);
}

Minefield*
minefield_construct (GType object_type,
                     guint width,
                     guint height,
                     guint n_mines)
{
	Minefield * self = NULL;
	Location** _tmp0_;
#line 138 "../src/minefield.vala"
	self = (Minefield*) g_object_new (object_type, NULL);
#line 140 "../src/minefield.vala"
	_tmp0_ = g_new0 (Location*, (width * height) + 1);
#line 140 "../src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 140 "../src/minefield.vala"
	self->locations = _tmp0_;
#line 140 "../src/minefield.vala"
	self->locations_length1 = width;
#line 140 "../src/minefield.vala"
	self->locations_length2 = height;
#line 366 "minefield.c"
	{
		gint x = 0;
#line 141 "../src/minefield.vala"
		x = 0;
#line 371 "minefield.c"
		{
			gboolean _tmp1_ = FALSE;
#line 141 "../src/minefield.vala"
			_tmp1_ = TRUE;
#line 141 "../src/minefield.vala"
			while (TRUE) {
#line 141 "../src/minefield.vala"
				if (!_tmp1_) {
#line 380 "minefield.c"
					gint _tmp2_;
#line 141 "../src/minefield.vala"
					_tmp2_ = x;
#line 141 "../src/minefield.vala"
					x = _tmp2_ + 1;
#line 386 "minefield.c"
				}
#line 141 "../src/minefield.vala"
				_tmp1_ = FALSE;
#line 141 "../src/minefield.vala"
				if (!(((guint) x) < width)) {
#line 141 "../src/minefield.vala"
					break;
#line 394 "minefield.c"
				}
				{
					gint y = 0;
#line 142 "../src/minefield.vala"
					y = 0;
#line 400 "minefield.c"
					{
						gboolean _tmp3_ = FALSE;
#line 142 "../src/minefield.vala"
						_tmp3_ = TRUE;
#line 142 "../src/minefield.vala"
						while (TRUE) {
#line 407 "minefield.c"
							Location** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Location* _tmp6_;
#line 142 "../src/minefield.vala"
							if (!_tmp3_) {
#line 414 "minefield.c"
								gint _tmp4_;
#line 142 "../src/minefield.vala"
								_tmp4_ = y;
#line 142 "../src/minefield.vala"
								y = _tmp4_ + 1;
#line 420 "minefield.c"
							}
#line 142 "../src/minefield.vala"
							_tmp3_ = FALSE;
#line 142 "../src/minefield.vala"
							if (!(((guint) y) < height)) {
#line 142 "../src/minefield.vala"
								break;
#line 428 "minefield.c"
							}
#line 143 "../src/minefield.vala"
							_tmp5_ = self->locations;
#line 143 "../src/minefield.vala"
							_tmp5__length1 = self->locations_length1;
#line 143 "../src/minefield.vala"
							_tmp5__length2 = self->locations_length2;
#line 143 "../src/minefield.vala"
							_tmp6_ = location_new ();
#line 143 "../src/minefield.vala"
							_g_object_unref0 (_tmp5_[(x * _tmp5__length2) + y]);
#line 143 "../src/minefield.vala"
							_tmp5_[(x * _tmp5__length2) + y] = _tmp6_;
#line 442 "minefield.c"
						}
					}
				}
			}
		}
	}
#line 144 "../src/minefield.vala"
	self->width = width;
#line 145 "../src/minefield.vala"
	self->height = height;
#line 146 "../src/minefield.vala"
	self->n_mines = n_mines;
#line 138 "../src/minefield.vala"
	return self;
#line 457 "minefield.c"
}

Minefield*
minefield_new (guint width,
               guint height,
               guint n_mines)
{
#line 138 "../src/minefield.vala"
	return minefield_construct (TYPE_MINEFIELD, width, height, n_mines);
#line 467 "minefield.c"
}

gboolean
minefield_is_clock_started (Minefield* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean result = FALSE;
#line 149 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/minefield.vala"
	_tmp0_ = minefield_get_elapsed (self);
#line 151 "../src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 151 "../src/minefield.vala"
	result = _tmp1_ > ((gdouble) 0);
#line 151 "../src/minefield.vala"
	return result;
#line 486 "minefield.c"
}

gboolean
minefield_has_mine (Minefield* self,
                    guint x,
                    guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean result = FALSE;
#line 154 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 156 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 156 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 156 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 156 "../src/minefield.vala"
	result = _tmp1_->has_mine;
#line 156 "../src/minefield.vala"
	return result;
#line 513 "minefield.c"
}

gboolean
minefield_is_cleared (Minefield* self,
                      guint x,
                      guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean result = FALSE;
#line 159 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 161 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 161 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 161 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 161 "../src/minefield.vala"
	result = _tmp1_->cleared;
#line 161 "../src/minefield.vala"
	return result;
#line 540 "minefield.c"
}

gboolean
minefield_is_location (Minefield* self,
                       gint x,
                       gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
#line 164 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 166 "../src/minefield.vala"
	if (x >= 0) {
#line 166 "../src/minefield.vala"
		_tmp2_ = y >= 0;
#line 558 "minefield.c"
	} else {
#line 166 "../src/minefield.vala"
		_tmp2_ = FALSE;
#line 562 "minefield.c"
	}
#line 166 "../src/minefield.vala"
	if (_tmp2_) {
#line 166 "../src/minefield.vala"
		_tmp1_ = ((guint) x) < self->width;
#line 568 "minefield.c"
	} else {
#line 166 "../src/minefield.vala"
		_tmp1_ = FALSE;
#line 572 "minefield.c"
	}
#line 166 "../src/minefield.vala"
	if (_tmp1_) {
#line 166 "../src/minefield.vala"
		_tmp0_ = ((guint) y) < self->height;
#line 578 "minefield.c"
	} else {
#line 166 "../src/minefield.vala"
		_tmp0_ = FALSE;
#line 582 "minefield.c"
	}
#line 166 "../src/minefield.vala"
	result = _tmp0_;
#line 166 "../src/minefield.vala"
	return result;
#line 588 "minefield.c"
}

void
minefield_multi_release (Minefield* self,
                         guint x,
                         guint y)
{
	gboolean _tmp0_ = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint n_unknown = 0U;
	gboolean do_clear = FALSE;
#line 169 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/minefield.vala"
	if (!minefield_is_cleared (self, x, y)) {
#line 171 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 607 "minefield.c"
	} else {
#line 171 "../src/minefield.vala"
		_tmp0_ = minefield_get_flag (self, x, y) == FLAG_TYPE_FLAG;
#line 611 "minefield.c"
	}
#line 171 "../src/minefield.vala"
	if (_tmp0_) {
#line 172 "../src/minefield.vala"
		return;
#line 617 "minefield.c"
	}
#line 175 "../src/minefield.vala"
	n_mines = minefield_get_n_adjacent_mines (self, x, y);
#line 176 "../src/minefield.vala"
	n_flags = (guint) 0;
#line 177 "../src/minefield.vala"
	n_unknown = (guint) 0;
#line 625 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 178 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 178 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 178 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 637 "minefield.c"
			Neighbour neighbour = {0};
#line 178 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 641 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp1_;
				gint ny = 0;
				Neighbour _tmp2_;
#line 180 "../src/minefield.vala"
				_tmp1_ = neighbour;
#line 180 "../src/minefield.vala"
				nx = ((gint) x) + _tmp1_.x;
#line 181 "../src/minefield.vala"
				_tmp2_ = neighbour;
#line 181 "../src/minefield.vala"
				ny = ((gint) y) + _tmp2_.y;
#line 182 "../src/minefield.vala"
				if (!minefield_is_location (self, nx, ny)) {
#line 183 "../src/minefield.vala"
					continue;
#line 659 "minefield.c"
				}
#line 184 "../src/minefield.vala"
				if (minefield_get_flag (self, (guint) nx, (guint) ny) == FLAG_TYPE_FLAG) {
#line 663 "minefield.c"
					guint _tmp3_;
#line 185 "../src/minefield.vala"
					_tmp3_ = n_flags;
#line 185 "../src/minefield.vala"
					n_flags = _tmp3_ + 1;
#line 669 "minefield.c"
				}
#line 186 "../src/minefield.vala"
				if (!minefield_is_cleared (self, (guint) nx, (guint) ny)) {
#line 673 "minefield.c"
					guint _tmp4_;
#line 187 "../src/minefield.vala"
					_tmp4_ = n_unknown;
#line 187 "../src/minefield.vala"
					n_unknown = _tmp4_ + 1;
#line 679 "minefield.c"
				}
			}
		}
	}
#line 193 "../src/minefield.vala"
	do_clear = FALSE;
#line 194 "../src/minefield.vala"
	if (n_mines == n_flags) {
#line 195 "../src/minefield.vala"
		do_clear = TRUE;
#line 690 "minefield.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 196 "../src/minefield.vala"
		_tmp6_ = minefield_get_use_autoflag (self);
#line 196 "../src/minefield.vala"
		_tmp7_ = _tmp6_;
#line 196 "../src/minefield.vala"
		if (_tmp7_) {
#line 196 "../src/minefield.vala"
			_tmp5_ = n_unknown == n_mines;
#line 703 "minefield.c"
		} else {
#line 196 "../src/minefield.vala"
			_tmp5_ = FALSE;
#line 707 "minefield.c"
		}
#line 196 "../src/minefield.vala"
		if (_tmp5_) {
#line 197 "../src/minefield.vala"
			do_clear = FALSE;
#line 713 "minefield.c"
		} else {
#line 199 "../src/minefield.vala"
			return;
#line 717 "minefield.c"
		}
	}
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 203 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 203 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 203 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 731 "minefield.c"
			Neighbour neighbour = {0};
#line 203 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 735 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp8_;
				gint ny = 0;
				Neighbour _tmp9_;
				gboolean _tmp10_ = FALSE;
#line 205 "../src/minefield.vala"
				_tmp8_ = neighbour;
#line 205 "../src/minefield.vala"
				nx = ((gint) x) + _tmp8_.x;
#line 206 "../src/minefield.vala"
				_tmp9_ = neighbour;
#line 206 "../src/minefield.vala"
				ny = ((gint) y) + _tmp9_.y;
#line 207 "../src/minefield.vala"
				if (!minefield_is_location (self, nx, ny)) {
#line 208 "../src/minefield.vala"
					continue;
#line 754 "minefield.c"
				}
#line 210 "../src/minefield.vala"
				if (do_clear) {
#line 210 "../src/minefield.vala"
					_tmp10_ = minefield_get_flag (self, (guint) nx, (guint) ny) != FLAG_TYPE_FLAG;
#line 760 "minefield.c"
				} else {
#line 210 "../src/minefield.vala"
					_tmp10_ = FALSE;
#line 764 "minefield.c"
				}
#line 210 "../src/minefield.vala"
				if (_tmp10_) {
#line 211 "../src/minefield.vala"
					minefield_clear_mine (self, (guint) nx, (guint) ny);
#line 770 "minefield.c"
				} else {
#line 213 "../src/minefield.vala"
					minefield_set_flag (self, (guint) nx, (guint) ny, FLAG_TYPE_FLAG);
#line 774 "minefield.c"
				}
			}
		}
	}
}

void
minefield_clear_mine (Minefield* self,
                      guint x,
                      guint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Location** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Location* _tmp4_;
	Location** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Location* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 217 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/minefield.vala"
	if (!self->placed_mines) {
#line 222 "../src/minefield.vala"
		minefield_place_mines (self, x, y);
#line 223 "../src/minefield.vala"
		self->placed_mines = TRUE;
#line 806 "minefield.c"
	}
#line 226 "../src/minefield.vala"
	if (!self->exploded) {
#line 810 "minefield.c"
		GTimer* _tmp1_;
#line 226 "../src/minefield.vala"
		_tmp1_ = self->priv->clock;
#line 226 "../src/minefield.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 816 "minefield.c"
	} else {
#line 226 "../src/minefield.vala"
		_tmp0_ = FALSE;
#line 820 "minefield.c"
	}
#line 226 "../src/minefield.vala"
	if (_tmp0_) {
#line 227 "../src/minefield.vala"
		minefield_start_clock (self);
#line 826 "minefield.c"
	}
#line 229 "../src/minefield.vala"
	_tmp3_ = self->locations;
#line 229 "../src/minefield.vala"
	_tmp3__length1 = self->locations_length1;
#line 229 "../src/minefield.vala"
	_tmp3__length2 = self->locations_length2;
#line 229 "../src/minefield.vala"
	_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
#line 229 "../src/minefield.vala"
	if (_tmp4_->cleared) {
#line 229 "../src/minefield.vala"
		_tmp2_ = TRUE;
#line 840 "minefield.c"
	} else {
		Location** _tmp5_;
		gint _tmp5__length1;
		gint _tmp5__length2;
		Location* _tmp6_;
		FlagType _tmp7_;
#line 229 "../src/minefield.vala"
		_tmp5_ = self->locations;
#line 229 "../src/minefield.vala"
		_tmp5__length1 = self->locations_length1;
#line 229 "../src/minefield.vala"
		_tmp5__length2 = self->locations_length2;
#line 229 "../src/minefield.vala"
		_tmp6_ = _tmp5_[(x * _tmp5__length2) + y];
#line 229 "../src/minefield.vala"
		_tmp7_ = _tmp6_->flag;
#line 229 "../src/minefield.vala"
		_tmp2_ = _tmp7_ == FLAG_TYPE_FLAG;
#line 859 "minefield.c"
	}
#line 229 "../src/minefield.vala"
	if (_tmp2_) {
#line 230 "../src/minefield.vala"
		return;
#line 865 "minefield.c"
	}
#line 232 "../src/minefield.vala"
	minefield_clear_mines_recursive (self, x, y);
#line 235 "../src/minefield.vala"
	_tmp8_ = self->locations;
#line 235 "../src/minefield.vala"
	_tmp8__length1 = self->locations_length1;
#line 235 "../src/minefield.vala"
	_tmp8__length2 = self->locations_length2;
#line 235 "../src/minefield.vala"
	_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 235 "../src/minefield.vala"
	if (_tmp9_->has_mine) {
#line 237 "../src/minefield.vala"
		if (!self->exploded) {
#line 239 "../src/minefield.vala"
			self->exploded = TRUE;
#line 240 "../src/minefield.vala"
			minefield_stop_clock (self);
#line 241 "../src/minefield.vala"
			g_signal_emit (self, minefield_signals[MINEFIELD_EXPLODE_SIGNAL], 0);
#line 887 "minefield.c"
		}
#line 243 "../src/minefield.vala"
		return;
#line 891 "minefield.c"
	}
#line 247 "../src/minefield.vala"
	_tmp10_ = minefield_get_is_complete (self);
#line 247 "../src/minefield.vala"
	_tmp11_ = _tmp10_;
#line 247 "../src/minefield.vala"
	if (_tmp11_) {
#line 249 "../src/minefield.vala"
		minefield_stop_clock (self);
#line 901 "minefield.c"
		{
			gint tx = 0;
#line 250 "../src/minefield.vala"
			tx = 0;
#line 906 "minefield.c"
			{
				gboolean _tmp12_ = FALSE;
#line 250 "../src/minefield.vala"
				_tmp12_ = TRUE;
#line 250 "../src/minefield.vala"
				while (TRUE) {
#line 250 "../src/minefield.vala"
					if (!_tmp12_) {
#line 915 "minefield.c"
						gint _tmp13_;
#line 250 "../src/minefield.vala"
						_tmp13_ = tx;
#line 250 "../src/minefield.vala"
						tx = _tmp13_ + 1;
#line 921 "minefield.c"
					}
#line 250 "../src/minefield.vala"
					_tmp12_ = FALSE;
#line 250 "../src/minefield.vala"
					if (!(((guint) tx) < self->width)) {
#line 250 "../src/minefield.vala"
						break;
#line 929 "minefield.c"
					}
					{
						gint ty = 0;
#line 251 "../src/minefield.vala"
						ty = 0;
#line 935 "minefield.c"
						{
							gboolean _tmp14_ = FALSE;
#line 251 "../src/minefield.vala"
							_tmp14_ = TRUE;
#line 251 "../src/minefield.vala"
							while (TRUE) {
#line 251 "../src/minefield.vala"
								if (!_tmp14_) {
#line 944 "minefield.c"
									gint _tmp15_;
#line 251 "../src/minefield.vala"
									_tmp15_ = ty;
#line 251 "../src/minefield.vala"
									ty = _tmp15_ + 1;
#line 950 "minefield.c"
								}
#line 251 "../src/minefield.vala"
								_tmp14_ = FALSE;
#line 251 "../src/minefield.vala"
								if (!(((guint) ty) < self->height)) {
#line 251 "../src/minefield.vala"
									break;
#line 958 "minefield.c"
								}
#line 252 "../src/minefield.vala"
								if (minefield_has_mine (self, (guint) tx, (guint) ty)) {
#line 253 "../src/minefield.vala"
									minefield_set_flag (self, (guint) tx, (guint) ty, FLAG_TYPE_FLAG);
#line 964 "minefield.c"
								}
							}
						}
					}
				}
			}
		}
#line 254 "../src/minefield.vala"
		g_signal_emit (self, minefield_signals[MINEFIELD_CLEARED_SIGNAL], 0);
#line 974 "minefield.c"
	}
}

static void
minefield_clear_mines_recursive (Minefield* self,
                                 guint x,
                                 guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	Location** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Location* _tmp3_;
	guint _tmp4_;
	Location** _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Location* _tmp6_;
	FlagType _tmp7_;
	Location** _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	Location* _tmp10_;
	gboolean _tmp11_ = FALSE;
	Location** _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	Location* _tmp13_;
#line 258 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 261 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 261 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 261 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 261 "../src/minefield.vala"
	if (_tmp1_->cleared) {
#line 262 "../src/minefield.vala"
		return;
#line 1020 "minefield.c"
	}
#line 264 "../src/minefield.vala"
	_tmp2_ = self->locations;
#line 264 "../src/minefield.vala"
	_tmp2__length1 = self->locations_length1;
#line 264 "../src/minefield.vala"
	_tmp2__length2 = self->locations_length2;
#line 264 "../src/minefield.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 264 "../src/minefield.vala"
	_tmp3_->cleared = TRUE;
#line 265 "../src/minefield.vala"
	_tmp4_ = self->priv->_n_cleared;
#line 265 "../src/minefield.vala"
	self->priv->_n_cleared = _tmp4_ + 1;
#line 266 "../src/minefield.vala"
	_tmp5_ = self->locations;
#line 266 "../src/minefield.vala"
	_tmp5__length1 = self->locations_length1;
#line 266 "../src/minefield.vala"
	_tmp5__length2 = self->locations_length2;
#line 266 "../src/minefield.vala"
	_tmp6_ = _tmp5_[(x * _tmp5__length2) + y];
#line 266 "../src/minefield.vala"
	_tmp7_ = _tmp6_->flag;
#line 266 "../src/minefield.vala"
	if (_tmp7_ == FLAG_TYPE_FLAG) {
#line 1048 "minefield.c"
		guint _tmp8_;
#line 267 "../src/minefield.vala"
		_tmp8_ = self->priv->_n_flags;
#line 267 "../src/minefield.vala"
		self->priv->_n_flags = _tmp8_ - 1;
#line 1054 "minefield.c"
	}
#line 268 "../src/minefield.vala"
	_tmp9_ = self->locations;
#line 268 "../src/minefield.vala"
	_tmp9__length1 = self->locations_length1;
#line 268 "../src/minefield.vala"
	_tmp9__length2 = self->locations_length2;
#line 268 "../src/minefield.vala"
	_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 268 "../src/minefield.vala"
	_tmp10_->flag = FLAG_TYPE_NONE;
#line 269 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
#line 270 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
#line 273 "../src/minefield.vala"
	_tmp12_ = self->locations;
#line 273 "../src/minefield.vala"
	_tmp12__length1 = self->locations_length1;
#line 273 "../src/minefield.vala"
	_tmp12__length2 = self->locations_length2;
#line 273 "../src/minefield.vala"
	_tmp13_ = _tmp12_[(x * _tmp12__length2) + y];
#line 273 "../src/minefield.vala"
	if (!_tmp13_->has_mine) {
#line 273 "../src/minefield.vala"
		_tmp11_ = minefield_get_n_adjacent_mines (self, x, y) == ((guint) 0);
#line 1082 "minefield.c"
	} else {
#line 273 "../src/minefield.vala"
		_tmp11_ = FALSE;
#line 1086 "minefield.c"
	}
#line 273 "../src/minefield.vala"
	if (_tmp11_) {
#line 1090 "minefield.c"
		{
			Neighbour* neighbour_collection = NULL;
			gint neighbour_collection_length1 = 0;
			gint _neighbour_collection_size_ = 0;
			gint neighbour_it = 0;
#line 275 "../src/minefield.vala"
			neighbour_collection = neighbour_map;
#line 275 "../src/minefield.vala"
			neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 275 "../src/minefield.vala"
			for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 1102 "minefield.c"
				Neighbour neighbour = {0};
#line 275 "../src/minefield.vala"
				neighbour = neighbour_collection[neighbour_it];
#line 1106 "minefield.c"
				{
					gint nx = 0;
					Neighbour _tmp14_;
					gint ny = 0;
					Neighbour _tmp15_;
#line 277 "../src/minefield.vala"
					_tmp14_ = neighbour;
#line 277 "../src/minefield.vala"
					nx = ((gint) x) + _tmp14_.x;
#line 278 "../src/minefield.vala"
					_tmp15_ = neighbour;
#line 278 "../src/minefield.vala"
					ny = ((gint) y) + _tmp15_.y;
#line 279 "../src/minefield.vala"
					if (minefield_is_location (self, nx, ny)) {
#line 280 "../src/minefield.vala"
						minefield_clear_mines_recursive (self, (guint) nx, (guint) ny);
#line 1124 "minefield.c"
					}
				}
			}
		}
	}
}

void
minefield_set_flag (Minefield* self,
                    guint x,
                    guint y,
                    FlagType flag)
{
	gboolean _tmp0_ = FALSE;
	Location** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Location* _tmp2_;
	Location** _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	Location* _tmp12_;
#line 285 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/minefield.vala"
	_tmp1_ = self->locations;
#line 287 "../src/minefield.vala"
	_tmp1__length1 = self->locations_length1;
#line 287 "../src/minefield.vala"
	_tmp1__length2 = self->locations_length2;
#line 287 "../src/minefield.vala"
	_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 287 "../src/minefield.vala"
	if (_tmp2_->cleared) {
#line 287 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 1161 "minefield.c"
	} else {
		Location** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		Location* _tmp4_;
		FlagType _tmp5_;
#line 287 "../src/minefield.vala"
		_tmp3_ = self->locations;
#line 287 "../src/minefield.vala"
		_tmp3__length1 = self->locations_length1;
#line 287 "../src/minefield.vala"
		_tmp3__length2 = self->locations_length2;
#line 287 "../src/minefield.vala"
		_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
#line 287 "../src/minefield.vala"
		_tmp5_ = _tmp4_->flag;
#line 287 "../src/minefield.vala"
		_tmp0_ = _tmp5_ == flag;
#line 1180 "minefield.c"
	}
#line 287 "../src/minefield.vala"
	if (_tmp0_) {
#line 288 "../src/minefield.vala"
		return;
#line 1186 "minefield.c"
	}
#line 290 "../src/minefield.vala"
	if (flag == FLAG_TYPE_FLAG) {
#line 1190 "minefield.c"
		guint _tmp6_;
#line 291 "../src/minefield.vala"
		_tmp6_ = self->priv->_n_flags;
#line 291 "../src/minefield.vala"
		self->priv->_n_flags = _tmp6_ + 1;
#line 1196 "minefield.c"
	} else {
		Location** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Location* _tmp8_;
		FlagType _tmp9_;
#line 292 "../src/minefield.vala"
		_tmp7_ = self->locations;
#line 292 "../src/minefield.vala"
		_tmp7__length1 = self->locations_length1;
#line 292 "../src/minefield.vala"
		_tmp7__length2 = self->locations_length2;
#line 292 "../src/minefield.vala"
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 292 "../src/minefield.vala"
		_tmp9_ = _tmp8_->flag;
#line 292 "../src/minefield.vala"
		if (_tmp9_ == FLAG_TYPE_FLAG) {
#line 1215 "minefield.c"
			guint _tmp10_;
#line 293 "../src/minefield.vala"
			_tmp10_ = self->priv->_n_flags;
#line 293 "../src/minefield.vala"
			self->priv->_n_flags = _tmp10_ - 1;
#line 1221 "minefield.c"
		}
	}
#line 295 "../src/minefield.vala"
	_tmp11_ = self->locations;
#line 295 "../src/minefield.vala"
	_tmp11__length1 = self->locations_length1;
#line 295 "../src/minefield.vala"
	_tmp11__length2 = self->locations_length2;
#line 295 "../src/minefield.vala"
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 295 "../src/minefield.vala"
	_tmp12_->flag = flag;
#line 296 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
#line 297 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
#line 1238 "minefield.c"
}

FlagType
minefield_get_flag (Minefield* self,
                    guint x,
                    guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	FlagType _tmp2_;
	FlagType result = 0;
#line 301 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 303 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 303 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 303 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 303 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 303 "../src/minefield.vala"
	_tmp2_ = _tmp1_->flag;
#line 303 "../src/minefield.vala"
	result = _tmp2_;
#line 303 "../src/minefield.vala"
	return result;
#line 1268 "minefield.c"
}

guint
minefield_get_n_adjacent_mines (Minefield* self,
                                guint x,
                                guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	guint result = 0U;
#line 306 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 308 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 308 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 308 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 308 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 308 "../src/minefield.vala"
	result = (guint) _tmp1_->adjacent_mines;
#line 308 "../src/minefield.vala"
	return result;
#line 1295 "minefield.c"
}

gboolean
minefield_has_flag_warning (Minefield* self,
                            guint x,
                            guint y)
{
	guint n_mines = 0U;
	guint n_flags = 0U;
	gboolean result = FALSE;
#line 311 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 313 "../src/minefield.vala"
	if (!minefield_is_cleared (self, x, y)) {
#line 314 "../src/minefield.vala"
		result = FALSE;
#line 314 "../src/minefield.vala"
		return result;
#line 1314 "minefield.c"
	}
#line 316 "../src/minefield.vala"
	n_mines = (guint) 0;
#line 316 "../src/minefield.vala"
	n_flags = (guint) 0;
#line 1320 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 317 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 317 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 317 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 1332 "minefield.c"
			Neighbour neighbour = {0};
#line 317 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1336 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp0_;
				gint ny = 0;
				Neighbour _tmp1_;
#line 319 "../src/minefield.vala"
				_tmp0_ = neighbour;
#line 319 "../src/minefield.vala"
				nx = ((gint) x) + _tmp0_.x;
#line 320 "../src/minefield.vala"
				_tmp1_ = neighbour;
#line 320 "../src/minefield.vala"
				ny = ((gint) y) + _tmp1_.y;
#line 321 "../src/minefield.vala"
				if (!minefield_is_location (self, nx, ny)) {
#line 322 "../src/minefield.vala"
					continue;
#line 1354 "minefield.c"
				}
#line 323 "../src/minefield.vala"
				if (minefield_has_mine (self, (guint) nx, (guint) ny)) {
#line 1358 "minefield.c"
					guint _tmp2_;
#line 324 "../src/minefield.vala"
					_tmp2_ = n_mines;
#line 324 "../src/minefield.vala"
					n_mines = _tmp2_ + 1;
#line 1364 "minefield.c"
				}
#line 325 "../src/minefield.vala"
				if (minefield_get_flag (self, (guint) nx, (guint) ny) == FLAG_TYPE_FLAG) {
#line 1368 "minefield.c"
					guint _tmp3_;
#line 326 "../src/minefield.vala"
					_tmp3_ = n_flags;
#line 326 "../src/minefield.vala"
					n_flags = _tmp3_ + 1;
#line 1374 "minefield.c"
				}
			}
		}
	}
#line 329 "../src/minefield.vala"
	result = n_flags > n_mines;
#line 329 "../src/minefield.vala"
	return result;
#line 1383 "minefield.c"
}

static void
minefield_place_mines (Minefield* self,
                       guint x,
                       guint y)
{
#line 333 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 1393 "minefield.c"
	{
		gint n = 0;
#line 335 "../src/minefield.vala"
		n = 0;
#line 1398 "minefield.c"
		{
			gboolean _tmp0_ = FALSE;
#line 335 "../src/minefield.vala"
			_tmp0_ = TRUE;
#line 335 "../src/minefield.vala"
			while (TRUE) {
#line 1405 "minefield.c"
				gint32 rx = 0;
				gint32 ry = 0;
				gboolean _tmp1_ = FALSE;
				Location** _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				Location* _tmp3_;
#line 335 "../src/minefield.vala"
				if (!_tmp0_) {
#line 1415 "minefield.c"
				}
#line 335 "../src/minefield.vala"
				_tmp0_ = FALSE;
#line 335 "../src/minefield.vala"
				if (!(((guint) n) < self->n_mines)) {
#line 335 "../src/minefield.vala"
					break;
#line 1423 "minefield.c"
				}
#line 337 "../src/minefield.vala"
				rx = g_random_int_range ((gint32) 0, (gint32) self->width);
#line 338 "../src/minefield.vala"
				ry = g_random_int_range ((gint32) 0, (gint32) self->height);
#line 340 "../src/minefield.vala"
				if (((guint) rx) == x) {
#line 340 "../src/minefield.vala"
					_tmp1_ = ((guint) ry) == y;
#line 1433 "minefield.c"
				} else {
#line 340 "../src/minefield.vala"
					_tmp1_ = FALSE;
#line 1437 "minefield.c"
				}
#line 340 "../src/minefield.vala"
				if (_tmp1_) {
#line 341 "../src/minefield.vala"
					continue;
#line 1443 "minefield.c"
				}
#line 343 "../src/minefield.vala"
				_tmp2_ = self->locations;
#line 343 "../src/minefield.vala"
				_tmp2__length1 = self->locations_length1;
#line 343 "../src/minefield.vala"
				_tmp2__length2 = self->locations_length2;
#line 343 "../src/minefield.vala"
				_tmp3_ = _tmp2_[(rx * _tmp2__length2) + ry];
#line 343 "../src/minefield.vala"
				if (!_tmp3_->has_mine) {
#line 1455 "minefield.c"
					gboolean adj_found = FALSE;
#line 345 "../src/minefield.vala"
					adj_found = FALSE;
#line 1459 "minefield.c"
					{
						Neighbour* neighbour_collection = NULL;
						gint neighbour_collection_length1 = 0;
						gint _neighbour_collection_size_ = 0;
						gint neighbour_it = 0;
#line 347 "../src/minefield.vala"
						neighbour_collection = neighbour_map;
#line 347 "../src/minefield.vala"
						neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 347 "../src/minefield.vala"
						for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 1471 "minefield.c"
							Neighbour neighbour = {0};
#line 347 "../src/minefield.vala"
							neighbour = neighbour_collection[neighbour_it];
#line 1475 "minefield.c"
							{
								gboolean _tmp4_ = FALSE;
								Neighbour _tmp5_;
#line 349 "../src/minefield.vala"
								_tmp5_ = neighbour;
#line 349 "../src/minefield.vala"
								if (((guint) rx) == (x + _tmp5_.x)) {
#line 1483 "minefield.c"
									Neighbour _tmp6_;
#line 349 "../src/minefield.vala"
									_tmp6_ = neighbour;
#line 349 "../src/minefield.vala"
									_tmp4_ = ((guint) ry) == (y + _tmp6_.y);
#line 1489 "minefield.c"
								} else {
#line 349 "../src/minefield.vala"
									_tmp4_ = FALSE;
#line 1493 "minefield.c"
								}
#line 349 "../src/minefield.vala"
								if (_tmp4_) {
#line 351 "../src/minefield.vala"
									adj_found = TRUE;
#line 352 "../src/minefield.vala"
									break;
#line 1501 "minefield.c"
								}
							}
						}
					}
#line 356 "../src/minefield.vala"
					if (!adj_found) {
#line 1508 "minefield.c"
						Location** _tmp7_;
						gint _tmp7__length1;
						gint _tmp7__length2;
						Location* _tmp8_;
						gint _tmp9_;
#line 358 "../src/minefield.vala"
						_tmp7_ = self->locations;
#line 358 "../src/minefield.vala"
						_tmp7__length1 = self->locations_length1;
#line 358 "../src/minefield.vala"
						_tmp7__length2 = self->locations_length2;
#line 358 "../src/minefield.vala"
						_tmp8_ = _tmp7_[(rx * _tmp7__length2) + ry];
#line 358 "../src/minefield.vala"
						_tmp8_->has_mine = TRUE;
#line 359 "../src/minefield.vala"
						_tmp9_ = n;
#line 359 "../src/minefield.vala"
						n = _tmp9_ + 1;
#line 1528 "minefield.c"
						{
							Neighbour* neighbour_collection = NULL;
							gint neighbour_collection_length1 = 0;
							gint _neighbour_collection_size_ = 0;
							gint neighbour_it = 0;
#line 360 "../src/minefield.vala"
							neighbour_collection = neighbour_map;
#line 360 "../src/minefield.vala"
							neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 360 "../src/minefield.vala"
							for (neighbour_it = 0; neighbour_it < neighbour_collection_length1; neighbour_it = neighbour_it + 1) {
#line 1540 "minefield.c"
								Neighbour neighbour = {0};
#line 360 "../src/minefield.vala"
								neighbour = neighbour_collection[neighbour_it];
#line 1544 "minefield.c"
								{
									gint32 nx = 0;
									Neighbour _tmp10_;
									gint32 ny = 0;
									Neighbour _tmp11_;
#line 362 "../src/minefield.vala"
									_tmp10_ = neighbour;
#line 362 "../src/minefield.vala"
									nx = rx + _tmp10_.x;
#line 363 "../src/minefield.vala"
									_tmp11_ = neighbour;
#line 363 "../src/minefield.vala"
									ny = ry + _tmp11_.y;
#line 364 "../src/minefield.vala"
									if (minefield_is_location (self, (gint) nx, (gint) ny)) {
#line 1560 "minefield.c"
										Location** _tmp12_;
										gint _tmp12__length1;
										gint _tmp12__length2;
										Location* _tmp13_;
										gint _tmp14_;
#line 365 "../src/minefield.vala"
										_tmp12_ = self->locations;
#line 365 "../src/minefield.vala"
										_tmp12__length1 = self->locations_length1;
#line 365 "../src/minefield.vala"
										_tmp12__length2 = self->locations_length2;
#line 365 "../src/minefield.vala"
										_tmp13_ = _tmp12_[(nx * _tmp12__length2) + ny];
#line 365 "../src/minefield.vala"
										_tmp14_ = _tmp13_->adjacent_mines;
#line 365 "../src/minefield.vala"
										_tmp13_->adjacent_mines = _tmp14_ + 1;
#line 1578 "minefield.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

static gboolean
_minefield_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = minefield_timeout_cb ((Minefield*) self);
#line 377 "../src/minefield.vala"
	return result;
#line 1597 "minefield.c"
}

static void
minefield_start_timer (Minefield* self)
{
#line 372 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/minefield.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 375 "../src/minefield.vala"
		g_source_remove (self->priv->clock_timeout);
#line 1609 "minefield.c"
	}
#line 376 "../src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 377 "../src/minefield.vala"
	self->priv->clock_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _minefield_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1615 "minefield.c"
}

static void
minefield_start_clock (Minefield* self)
{
	GTimer* _tmp0_;
#line 380 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 382 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 1628 "minefield.c"
		GTimer* _tmp1_;
#line 383 "../src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 383 "../src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 383 "../src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 1636 "minefield.c"
	}
#line 384 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL], 0);
#line 385 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 386 "../src/minefield.vala"
	minefield_start_timer (self);
#line 1644 "minefield.c"
}

static void
minefield_stop_clock (Minefield* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
	GTimer* _tmp2_;
#line 389 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 391 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 392 "../src/minefield.vala"
		return;
#line 1661 "minefield.c"
	}
#line 393 "../src/minefield.vala"
	_tmp1_ = self->priv->clock;
#line 393 "../src/minefield.vala"
	self->priv->clock_elapsed = self->priv->clock_elapsed + g_timer_elapsed (_tmp1_, NULL);
#line 394 "../src/minefield.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 395 "../src/minefield.vala"
		g_source_remove (self->priv->clock_timeout);
#line 1671 "minefield.c"
	}
#line 396 "../src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 397 "../src/minefield.vala"
	_tmp2_ = self->priv->clock;
#line 397 "../src/minefield.vala"
	g_timer_stop (_tmp2_);
#line 398 "../src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 398 "../src/minefield.vala"
	self->priv->clock = NULL;
#line 399 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 1685 "minefield.c"
}

static void
minefield_continue_clock (Minefield* self)
{
	GTimer* _tmp0_;
#line 402 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 404 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 1698 "minefield.c"
		GTimer* _tmp1_;
#line 405 "../src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 405 "../src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 405 "../src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 1706 "minefield.c"
	} else {
		GTimer* _tmp2_;
#line 407 "../src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 407 "../src/minefield.vala"
		g_timer_continue (_tmp2_);
#line 1713 "minefield.c"
	}
#line 408 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 409 "../src/minefield.vala"
	minefield_start_timer (self);
#line 1719 "minefield.c"
}

static gboolean
minefield_timeout_cb (Minefield* self)
{
	gboolean result = FALSE;
#line 412 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 414 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 415 "../src/minefield.vala"
	result = TRUE;
#line 415 "../src/minefield.vala"
	return result;
#line 1734 "minefield.c"
}

guint
minefield_get_n_cleared (Minefield* self)
{
	guint result;
#line 77 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "../src/minefield.vala"
	result = self->priv->_n_cleared;
#line 77 "../src/minefield.vala"
	return result;
#line 1747 "minefield.c"
}

gboolean
minefield_get_is_complete (Minefield* self)
{
	gboolean result;
#line 82 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "../src/minefield.vala"
	result = self->priv->_n_cleared == ((self->width * self->height) - self->n_mines);
#line 82 "../src/minefield.vala"
	return result;
#line 1760 "minefield.c"
}

guint
minefield_get_n_flags (Minefield* self)
{
	guint result;
#line 87 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 87 "../src/minefield.vala"
	result = self->priv->_n_flags;
#line 87 "../src/minefield.vala"
	return result;
#line 1773 "minefield.c"
}

gboolean
minefield_get_use_autoflag (Minefield* self)
{
	gboolean result;
#line 92 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "../src/minefield.vala"
	result = self->_use_autoflag;
#line 92 "../src/minefield.vala"
	return result;
#line 1786 "minefield.c"
}

void
minefield_set_use_autoflag (Minefield* self,
                            gboolean value)
{
#line 93 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/minefield.vala"
	self->_use_autoflag = value;
#line 93 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY]);
#line 1799 "minefield.c"
}

gdouble
minefield_get_elapsed (Minefield* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	GTimer* _tmp1_;
#line 103 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 105 "../src/minefield.vala"
	_tmp1_ = self->priv->clock;
#line 105 "../src/minefield.vala"
	if (_tmp1_ == NULL) {
#line 105 "../src/minefield.vala"
		_tmp0_ = 0.0;
#line 1816 "minefield.c"
	} else {
		GTimer* _tmp2_;
#line 105 "../src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 105 "../src/minefield.vala"
		_tmp0_ = g_timer_elapsed (_tmp2_, NULL);
#line 1823 "minefield.c"
	}
#line 105 "../src/minefield.vala"
	result = self->priv->clock_elapsed + _tmp0_;
#line 105 "../src/minefield.vala"
	return result;
#line 1829 "minefield.c"
}

gboolean
minefield_get_paused (Minefield* self)
{
	gboolean result;
#line 125 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../src/minefield.vala"
	result = self->priv->_paused;
#line 125 "../src/minefield.vala"
	return result;
#line 1842 "minefield.c"
}

void
minefield_set_paused (Minefield* self,
                      gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 112 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/minefield.vala"
	_tmp1_ = minefield_get_is_complete (self);
#line 114 "../src/minefield.vala"
	_tmp2_ = _tmp1_;
#line 114 "../src/minefield.vala"
	if (_tmp2_) {
#line 114 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 1863 "minefield.c"
	} else {
#line 114 "../src/minefield.vala"
		_tmp0_ = self->exploded;
#line 1867 "minefield.c"
	}
#line 114 "../src/minefield.vala"
	if (_tmp0_) {
#line 115 "../src/minefield.vala"
		return;
#line 1873 "minefield.c"
	}
#line 117 "../src/minefield.vala"
	if (value) {
#line 117 "../src/minefield.vala"
		_tmp3_ = !self->priv->_paused;
#line 1879 "minefield.c"
	} else {
#line 117 "../src/minefield.vala"
		_tmp3_ = FALSE;
#line 1883 "minefield.c"
	}
#line 117 "../src/minefield.vala"
	if (_tmp3_) {
#line 118 "../src/minefield.vala"
		minefield_stop_clock (self);
#line 1889 "minefield.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 119 "../src/minefield.vala"
		if (!value) {
#line 119 "../src/minefield.vala"
			_tmp4_ = self->priv->_paused;
#line 1896 "minefield.c"
		} else {
#line 119 "../src/minefield.vala"
			_tmp4_ = FALSE;
#line 1900 "minefield.c"
		}
#line 119 "../src/minefield.vala"
		if (_tmp4_) {
#line 120 "../src/minefield.vala"
			minefield_continue_clock (self);
#line 1906 "minefield.c"
		}
	}
#line 122 "../src/minefield.vala"
	self->priv->_paused = value;
#line 123 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL], 0);
#line 112 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_PAUSED_PROPERTY]);
#line 1915 "minefield.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 51 "../src/minefield.vala"
	g_return_if_fail (n_param_values == 3);
#line 51 "../src/minefield.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 51 "../src/minefield.vala"
		data1 = closure->data;
#line 51 "../src/minefield.vala"
		data2 = param_values->data[0].v_pointer;
#line 1940 "minefield.c"
	} else {
#line 51 "../src/minefield.vala"
		data1 = param_values->data[0].v_pointer;
#line 51 "../src/minefield.vala"
		data2 = closure->data;
#line 1946 "minefield.c"
	}
#line 51 "../src/minefield.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 51 "../src/minefield.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 1952 "minefield.c"
}

static void
minefield_class_init (MinefieldClass * klass,
                      gpointer klass_data)
{
#line 51 "../src/minefield.vala"
	minefield_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/minefield.vala"
	g_type_class_adjust_private_offset (klass, &Minefield_private_offset);
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_minefield_get_property;
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_minefield_set_property;
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = minefield_finalize;
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_CLEARED_PROPERTY, minefield_properties[MINEFIELD_N_CLEARED_PROPERTY] = g_param_spec_uint ("n-cleared", "n-cleared", "n-cleared", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_IS_COMPLETE_PROPERTY, minefield_properties[MINEFIELD_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_FLAGS_PROPERTY, minefield_properties[MINEFIELD_N_FLAGS_PROPERTY] = g_param_spec_uint ("n-flags", "n-flags", "n-flags", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_USE_AUTOFLAG_PROPERTY, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY] = g_param_spec_boolean ("use-autoflag", "use-autoflag", "use-autoflag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_ELAPSED_PROPERTY, minefield_properties[MINEFIELD_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_PAUSED_PROPERTY, minefield_properties[MINEFIELD_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL] = g_signal_new ("clock-started", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_TICK_SIGNAL] = g_signal_new ("tick", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL] = g_signal_new ("redraw-sector", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL] = g_signal_new ("marks-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_EXPLODE_SIGNAL] = g_signal_new ("explode", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1995 "minefield.c"
}

static void
minefield_instance_init (Minefield * self,
                         gpointer klass)
{
#line 51 "../src/minefield.vala"
	self->priv = minefield_get_instance_private (self);
#line 54 "../src/minefield.vala"
	self->width = (guint) 0;
#line 55 "../src/minefield.vala"
	self->height = (guint) 0;
#line 58 "../src/minefield.vala"
	self->n_mines = (guint) 0;
#line 64 "../src/minefield.vala"
	self->exploded = FALSE;
#line 67 "../src/minefield.vala"
	self->placed_mines = FALSE;
#line 70 "../src/minefield.vala"
	self->priv->_n_cleared = (guint) 0;
#line 71 "../src/minefield.vala"
	self->priv->_n_flags = (guint) 0;
#line 109 "../src/minefield.vala"
	self->priv->_paused = FALSE;
#line 2020 "minefield.c"
}

static void
minefield_finalize (GObject * obj)
{
	Minefield * self;
#line 51 "../src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINEFIELD, Minefield);
#line 61 "../src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 98 "../src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (minefield_parent_class)->finalize (obj);
#line 2035 "minefield.c"
}

GType
minefield_get_type (void)
{
	static volatile gsize minefield_type_id__volatile = 0;
	if (g_once_init_enter (&minefield_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MinefieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minefield_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Minefield), 0, (GInstanceInitFunc) minefield_instance_init, NULL };
		GType minefield_type_id;
		minefield_type_id = g_type_register_static (G_TYPE_OBJECT, "Minefield", &g_define_type_info, 0);
		Minefield_private_offset = g_type_add_instance_private (minefield_type_id, sizeof (MinefieldPrivate));
		g_once_init_leave (&minefield_type_id__volatile, minefield_type_id);
	}
	return minefield_type_id__volatile;
}

static void
_vala_minefield_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 51 "../src/minefield.vala"
	switch (property_id) {
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_CLEARED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_cleared (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_IS_COMPLETE_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_is_complete (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_FLAGS_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_flags (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_use_autoflag (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_ELAPSED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_double (value, minefield_get_elapsed (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_PAUSED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_paused (self));
#line 51 "../src/minefield.vala"
		break;
#line 2098 "minefield.c"
		default:
#line 51 "../src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 51 "../src/minefield.vala"
		break;
#line 2104 "minefield.c"
	}
}

static void
_vala_minefield_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 51 "../src/minefield.vala"
	switch (property_id) {
#line 51 "../src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_use_autoflag (self, g_value_get_boolean (value));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_PAUSED_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_paused (self, g_value_get_boolean (value));
#line 51 "../src/minefield.vala"
		break;
#line 2130 "minefield.c"
		default:
#line 51 "../src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 51 "../src/minefield.vala"
		break;
#line 2136 "minefield.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

